Subject: Re: IPv6 nexthop for IPv4

From: Andy Gospodarek <[email-masked]>
Date: Thu, 26 Mar 2015 12:27:59 -0400

On Thu, Mar 26, 2015 at 11:43:36AM -0400, John W. Linville wrote:
> On Thu, Mar 26, 2015 at 04:10:21PM +0100, Bjørnar Ness wrote:
> > 2015-03-26 15:53 GMT+01:00 Sowmini Varadhan <[email-masked]>:
> > > On Thu, Mar 26, 2015 at 10:39 AM, Bjørnar Ness <[email-masked]> wrote:
> > >
> > >>>> ip route add 10.0.0.0/16 via fe80::225:90ff:fed3:bfb4/64 dev sfp0
> > >>>
> > >>> Trying to understand what the desired behavior is, for the route
> > >>> above: if I send a packet from 10.0.0.1 to 10.0.0.2, you want the dst-mac
> > >>> to be the mac address of e80::225:90ff:fed3:bfb4???
> > >>
> > >> Absolutely, correct.
> > >
> > > What if the current node does not want to support ipv6? This sounds
> > > pretty "creative", if this can work, you might as well make the nexthop to
> > > be the L2 address of the gw.
> > 
> > If it does not support IPv6 I guess the route command will fail! This
> > is a bad argument
> > against this. Dont see the point of limiting nexthop to L2
> 
> This topic was discussed at the recent Netconf event in Ottawa.
> This is a viable means of interconnecting two IPv4 "island" subnets
> across an IPv6 "ocean" backplane.
> 
> Andy Gospodarek gave a short discussion on the topic, and IIRC it
> was warmly received.  I'll Cc him on this message -- I think he had a
> (fairly simple) patch more or less ready.

Yes, I do have one!  I was working on some other issues and need to
rebase it based on Eric's recent work.  It was fairly simple and the
netlink changes are also not too difficult so the patch to iproute2 was
small.

I have an older patch you can see here:

https://github.com/gospo/net-next/commit/7f602a54424f453872b6a45ae5ed4d3a601db91d

Shall I rebase and post to the list for all to see?